﻿'******************************************************
' felicalib.dll が存在しているかチェックするための機能
'******************************************************
Imports System.Runtime.InteropServices

Module modIsDLLExists
    '===================================
    ' Win32 API (DLL存在チェックに必要)
    '===================================
    <DllImport("kernel32", CallingConvention:=CallingConvention.StdCall)> _
    Private Function SetDllDirectory(ByVal lpPathName As String) As Boolean
    End Function

    <DllImport("kernel32", CallingConvention:=CallingConvention.StdCall)> _
    Private Function LoadLibrary(ByVal lpLibFileName As String) As Integer
    End Function

    <DllImport("kernel32", CallingConvention:=CallingConvention.StdCall)> _
    Private Function GetProcAddress(ByVal hModule As Integer, ByVal lpProcName As String) As Integer
    End Function

    <DllImport("kernel32", CallingConvention:=CallingConvention.StdCall)> _
    Private Function FreeLibrary(ByVal hLibModule As Integer) As Boolean
    End Function

    '====================================================
    '【関数名】isDLLExists
    '【引  数】なし
    '【戻り値】[out] Boolean  TRUE   DLLの読み込みに成功
    '                         FALSE  DLLの読み込みに失敗
    '----------------------------------------------------
    ' felicalib.dll が存在するかチェックする。
    '====================================================
    Public Function isDLLExists() As Boolean
        'DLLのハンドル
        Dim hModule As IntPtr = IntPtr.Zero

        'DLL内の関数を受け取るポインタ
        Dim pPasoriOpen As IntPtr = IntPtr.Zero
        Dim pPasoriClose As IntPtr = IntPtr.Zero
        Dim pPasoriInit As IntPtr = IntPtr.Zero
        Dim pFelicaPolling As IntPtr = IntPtr.Zero
        Dim pFelicaFree As IntPtr = IntPtr.Zero
        Dim pFelicaGetidm As IntPtr = IntPtr.Zero
        Dim pFelicaGetpmm As IntPtr = IntPtr.Zero
        Dim pFelicaReadWithoutEncryption02 As IntPtr = IntPtr.Zero
        Dim pFelicaWriteWithoutEncryption As IntPtr = IntPtr.Zero
        Dim pFelicaEnumSystemcode As IntPtr = IntPtr.Zero
        Dim pFelicaEnumService As IntPtr = IntPtr.Zero

        Try
            'DLLプリロード対策 ※DLLの読み込み先から現在の作業ディレクトリ(CWD)を除外する
            SetDllDirectory("")

            'DLLを読み込む
            hModule = LoadLibrary("felicalib.dll")
            If hModule = IntPtr.Zero Then
                Return False
            End If

            'DLLの関数を読み込む
            pPasoriOpen = GetProcAddress(hModule, "pasori_open")
            pPasoriClose = GetProcAddress(hModule, "pasori_close")
            pPasoriInit = GetProcAddress(hModule, "pasori_init")
            pFelicaPolling = GetProcAddress(hModule, "felica_polling")
            pFelicaFree = GetProcAddress(hModule, "felica_free")
            pFelicaGetidm = GetProcAddress(hModule, "felica_getidm")
            pFelicaGetpmm = GetProcAddress(hModule, "felica_getpmm")
            pFelicaReadWithoutEncryption02 = GetProcAddress(hModule, "felica_read_without_encryption02")
            pFelicaWriteWithoutEncryption = GetProcAddress(hModule, "felica_write_without_encryption")
            pFelicaEnumSystemcode = GetProcAddress(hModule, "felica_enum_systemcode")
            pFelicaEnumService = GetProcAddress(hModule, "felica_enum_service")

            If pPasoriOpen = IntPtr.Zero OrElse _
               pPasoriClose = IntPtr.Zero OrElse _
               pPasoriInit = IntPtr.Zero OrElse _
               pFelicaPolling = IntPtr.Zero OrElse _
               pFelicaFree = IntPtr.Zero OrElse _
               pFelicaGetidm = IntPtr.Zero OrElse _
               pFelicaGetpmm = IntPtr.Zero OrElse _
               pFelicaReadWithoutEncryption02 = IntPtr.Zero OrElse _
               pFelicaWriteWithoutEncryption = IntPtr.Zero OrElse _
               pFelicaEnumSystemcode = IntPtr.Zero OrElse _
               pFelicaEnumService = IntPtr.Zero _
            Then
                FreeLibrary(hModule)
                Return False
            End If

            '読み込み成功
            FreeLibrary(hModule)
            Return True
        Catch ex As Exception
            MessageBox.Show(ex.Message, "isDLLExists()")
            If hModule <> IntPtr.Zero Then FreeLibrary(hModule)
            Return False
        End Try
    End Function
End Module
